/***************************************************************************
 *   m3u.cpp - handles the logic/function of creating, editing (not yet)   *
 *             or deleting the favourites playlist qaplay.m3u              *
 *                                                                         *
 *   Copyright (C) 2005-2014 by Helge Kortendieck   alan@kasmithee.de      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "m3u.h"
	int m3uiD;

	QString sD;
	QString m3usD;

	QStringList m3uslD;


int m3uExists()								// check whether ~/.config/qaplay/qaplay.m3u exists and is writable, 0=no, 1=yes/writable, 2=yes/not writable
{
	m3usD = QDir::home().absolutePath();
//cout << "exists() - QDir::home(): " << m3usD.toStdString() << endl;                                               // *****  debug  *****
	QFileInfo fi (QDir::home().absolutePath() + "/.config/qaplay/qaplay.m3u");
	m3uiD = 0;
	if (fi.exists() == true) {
		if (fi.isWritable() == true) {
			m3uiD = 1;								// exists and writable
		} else {
			m3uiD = 2;								// exists but not writable
		}
	} else {
		m3uiD = 0;									// does not exist
	}
	return m3uiD;
}

int m3uCreate()								// create new, empty ~/.config/qaplay/qaplay.m3u playlist, 0=err, 1=success, 2=...
{
	m3uslD.clear();
	m3uslD.append("#EXTM3U");					// m3u header
	return m3uWrite(m3uslD);
}

/*  slTlmm3u.clear();                         // slTlmm3u will become the playlist tlm.m3u
  slTlmm3u.append( "#EXTM3U" );             //creating the header

// read the directory into the QStringlist slSongNamesInDir
// for each file matching the audio only file filter:
//          check the tag info via tablib
//    and   create the 2 line tlmm3u entry
//    and   attach it to slTlmm3u
  sAudioFilter = Settings::audioFilter();   // audio only file filter for qdir from settings dialog
  QDir d( sSongDir );
    d.setFilter( QDir::Files);
    d.setNameFilter( sAudioFilter );
  iCountSongsInDir = 0;
  slSongNamesInDir = d.entryList();            // create a qstringlist with the dir entries (song names)
  iCountSongsInDir = slSongNamesInDir.count(); // and count number songs

  if (iCountSongsInDir == 0) {                 // no songs to process, this was quick :-)
    sInfo = I18N_NOOP("Next, cannot find any song in this directory!<br>\
                       Check the audio-only file filter in the config/settings screen (c-key).<br>\
                       Aborting !<br> <br>\
                       4 sec to close...");
  } else {                                     // found at least one song: continue to create tlm.m3u
    // iterate over the QStringlist slSongNamesInDir and try to get a tag for each entry
    // in any case, create the 2 line entry for the tlm.m3u playlist, attach to slTlmm3u first
    for ( QStringList::Iterator it = slSongNamesInDir.begin(); it != slSongNamesInDir.end(); ++it ) {
      sDummy = *it;
      TagLib::FileRef f( sSongDir + sDummy );
      sTagArtist = TStringToQString( f.tag()->artist() );
      sTagTitle = TStringToQString( f.tag()->title() );
      sTagLength = QString::number( f.audioProperties()->length() );      // song length in seconds

      if (sTagArtist == "")
        sTagArtist = "no tag";
      if (sTagTitle == "")
        sTagTitle = "no tag";
      if (sTagLength == "0")
        sTagLength = "1";                      // don't know, if 0 gives any program a problem??

      sIn = "#EXTINF:" + sTagLength + "," + sTagArtist + " - " + sTagTitle;
      slTlmm3u.append( sIn );                  // add the first line of the m3u entry
      slTlmm3u.append( sSongDir + sDummy );    // add the path and file name of song, 2nd line of entry
    }                                          // next dir entry (song) to process

    // finally create the playlist from slTlmm3u
    QFile file( sSongDir + "tlm.m3u" );
    if ( file.open( IO_WriteOnly ) ) {
      QTextStream stream( &file );
      for ( QStringList::Iterator it = slTlmm3u.begin(); it != slTlmm3u.end(); ++it )
        stream << *it << "\n";
      file.close();
    }
  }*/

/*
void tlmm3uMenu::doDeleteM3u()
{
  QFile file( sSongDir + "tlm.m3u" );            // delete the tlm.m3u
  file.remove();
  QFileInfo fi( sSongDir + "tlm.m3u" );              // check for tlm.m3u in the current directory
  if ( fi.exists() ) {                               // there is already a tlm.m3u playlist in this dir
    sInfo = I18N_NOOP("My deepest regret!<br>\
                       I could not delete tlm.m3u !<br> <br>\
                       This could be a file permission problem.<br> <br>\
                       4 sec to close...");
  } else {
    bTlmm3uExists = false;
    sInfo = I18N_NOOP("tlm.m3u DELETED !<br> <br>\
                       4 sec to close...");
  }
  infoShow();
  infoTimer();
  menuItemState();
}
*/

/*
// *************************************************
// edit the current tlm.m3u playlist
// *************************************************
void tlmm3uMenu::editM3u()                 // show tlm.m3u edit widget
{

//QMessageBox::warning(0, "debug tlmM3uMenu", "tlmM3uMenu reached");	// ********************* debug
  m3uedit->tL_Dummy->setText( sSongDir );
  m3uedit->lB_Edit->clear();
  m3uedit->tL_Grabbed->clear();
  m3uedit->show();                                    // show tlm.m3u edit widget
  m3uedit->showFullScreen();
  this->hide();                                       // hide this after show => reduce flicker
  bTlmM3uEdit = true;
  editM3uRead();
}
*/

QStringList m3uRead(const QString& sD)	// read ~/.config/qaplay/qaplay.m3u, 0=err, 1=success
{
	m3uslD.clear();
	QFile f(sD);													//QDir::home().absolutePath() + "/.config/qaplay/qaplay.m3u");
	if (!f.open(QIODevice::ReadOnly | QIODevice::Text))
		return m3uslD;

	QTextStream in(&f);
	while (!in.atEnd()) {
		m3usD = in.readLine();
		if(m3usD.left(1) != "#") {
			m3uslD.append(m3usD);				// no check for valid entries so far
		}
    }
	f.close();
	return m3uslD;
}

/*
void tlmm3uMenu::editM3uUpdate()         // generate slTlmm3uEditView from slTlmm3uEdit n update qlistbox
{
  // prepare the qlistview window 'playlistWindow' to receive the mp3 filenames
  m3uedit->lB_Edit->clear();                          // initially clear view

  sIn = "";                                           // becomes the line we read in
  iCountSongsTlmm3u = 0;                              // counter of songs in tlm.m3u
  slTlmm3uEditView.clear();                           // start with an empty qstringlist

  for ( QStringList::Iterator it = slTlmm3uEdit.begin(); it != slTlmm3uEdit.end(); ++it ) {

    sIn = QString(*it);                                        // read line by line
    if (sIn.left (1) != "#") {                        // a line without '#' at the beginning = url
      iCountSongsTlmm3u = iCountSongsTlmm3u + 1;
      sDummy = QString::number(iCountSongsTlmm3u);
      if (iCountSongsTlmm3u < 10) {                   // format 1 - 9 to 01 - 09
        sDummy = "  " + sDummy;
      }

      iDummy = sIn.findRev( '/' );                    // find position of start of song name from path
      sDummy2 = sIn.remove( 0 , iDummy + 1 );         // remove path including last '/' = file/song name

      // EditView with format number + " " + file (song) name (excl. path)
      slTlmm3uEditView.append( sDummy + "   " + sDummy2);
    }
  }
  editM3uFill();                                      // now fill the qlistbox
}*/

int m3uWrite(const QStringList& m3uslD)		// save ~/.config/qaplay/qaplay.m3u, 0=err, 1=success
{
	QDir d(QDir::homePath() + "/.config/qaplay");
	if (d.exists() == false) {
		d.setPath(QDir::homePath());
		if (d.mkdir(".config/qaplay") == false) {
			return 0;
		}
	}
	QFile f(QDir::homePath() + "/.config/qaplay/qaplay.m3u");
	if (f.exists() == true) {					// if the m3u exists - create a temporary backup first
		if (f.rename(QDir::homePath() + "/.config/qaplay/qaplay.m3u.bak") != true) {
			return 0;
		}
	}
	f.setFileName(QDir::homePath() + "/.config/qaplay/qaplay.m3u");
	if (f.open(QFile::WriteOnly | QFile::Text)) {                  // re-creating m3u playlist with actual songs
		QTextStream stream( &f );
		for (int i = 0; i < m3uslD.size(); ++i) {
			stream << m3uslD.at(i) << "\n";
		}
		f.close();
		f.setFileName(QDir::homePath() + "/.config/qaplay/qaplay.m3u.bak");	// remove temporary backup
		if (f.exists() == true) {				// if the m3u.bak exists - delete now
			if (f.remove() == true) {
				return 1;
			} else {
				return 0;
			}
		} else {
			return 1;
		}
	} else {
//cout << "m3uWrite() f.open failed: " << endl;                                               // *****  debug  *****
		return 0;
	}
}

/*
// ******************************************************************
// delete song
// ******************************************************************
void tlmm3uMenu::editM3uDelSong()           // ask to delete song from tlm.m3u playlist (not from disc)
{
  if(bTlmM3uEdit and bMove) {               // only do something, when in tlm.m3u edit mode and item selected
    sAction = "deleteSong";
    sDummy = m3uedit->lB_Edit->text(iCursorPos);
    sInfo = I18N_NOOP("Sure to delete the song<br>" + sDummy + "<br>from the tlm.m3u playlist?<br> <br>\
                       Hit OK to proceed or ESC to cancel.");
    infoShow();
  }
} */

/*
void tlmm3uMenu::editM3uDelSongDo()                   // delete song from tlm.m3u playlist (not from disc)
{
  if(bTlmM3uEdit) {                                   // only do something, when in tlm.m3u edit mode
    iMoveStartSl = iCursorPos * 2 + 1 ;               // pos of item in slTlmm3uEdit when start moving
    slTESaveRem();                                    // save and remove items to be moved in slTlmm3uEdit
    sInfo = I18N_NOOP("Song deleted!<br> <br>\
                       4 sec to close...");           // show abort info
    info->tE_Info->setText( "<center>" + sInfo + "</center>" );
//    infoShow( true );
    infoTimer();
    editM3uUpdate();                                  // update slTlmm3uEditView and then qlistbox
  }
}
*/
