/***************************************************************************
 *   Copyright (C) 2006-2022 by Helge Kortendieck  alan@kasmithee.de       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "qaplay.h"

#include <QApplication>
#include <QFile>
#include <QStringList>

#include <iostream>
using namespace std;

int main(int argc, char **argv)
{
  QApplication app(argc, argv);
  app.setQuitOnLastWindowClosed(false);
  QStringList slArgs = QApplication::arguments();  // get command line args
  int iArgs = slArgs.count();

  if(iArgs != 2) {
    cout << "###  qaplay - Qt5 based audio player using gstreamer0.10\n"
	        "###  Intended to play sounds by clicking on them in a GUI file manager.\n"
            "###  Adds a stop button in the system tray to allow to\n"
            "###  stop playing the current sound.\n"
            "###  Creates a playlist of all files in the dir a song is started.\n"
            "###  Allows to select previous/next song, to select from the play list\n"
            "###  and add to a favorite playlist (and play this one).\n"
            "###  \n"
	        "###  Version 3.0.4\n"
	        "###  Copyright (C) 2006-2020 by Helge Kortendieck, alan@kasmithee.de\n"
            "###  Released under GPL2 (or later)\n"
            "###  \n"
            "###  Use 'man qaplay' to see a short program description.\n"
            "###  \n"
            "###  This program requires Qt5, X11 and a systemtray.\n"
            "###  Start the program with exact 1 argument:\n"
            "###  the full path and name to the audio file to play.\n"
            "###  While running, right click on the tray icon and\n"
            "###  select the online help to learn more about qaplay.\n" << endl;
    return 0;
  };

  Qaplay qplayer;
  qplayer.show();
  return app.exec();
}
