/***************************************************************************
 *   Copyright (C) 2014-2022 by Helge Kortendieck  alan@kasmithee.de       *
 *   playlist.cpp  -  show playlist: either list of songs in current dir   *
 *                                   or favourites playlist                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#include "playlist.h"

PlayList::PlayList(QDialog* parent)
	: QDialog(parent)
{
	uisl.setupUi(&wSl);
	connect(uisl.pB_Close, SIGNAL(clicked()), this, SLOT(closeDlg()));
}

PlayList::~PlayList()
{
}

void PlayList::showSl(const QStringList& slDSl)	// show song list, current dir or favourites songs
{
	uisl.l_DirFav->setText(tr("foo"));
	uisl.lw_PlayList->clear();
	for(iD = 0 ; iD < slDSl.count() ; iD++) {
		QListWidgetItem *newSongItem = new QListWidgetItem(slDSl.at(iD));
//			newHistItem->setFlags( Qt::ItemIsSelectable | Qt::ItemIsEnabled );
		uisl.lw_PlayList->addItem(newSongItem);
	}
//	uisl.lw_SongList->setText(siDSi.sArtist);
	
	qPos = QCursor::pos();
	iD = qPos.x() - 500;
	if( iD < 0 ) {
		iD = 0;
	}
	iD2 = qPos.y() - 210;
	if( iD2 < 0 ) {
		iD2 = 0;
	}
	wSl.move( iD, iD2 );
	wSl.show();
}


void PlayList::closeDlg()
{
	emit sigDelPlayList();
}


//#include "playlist.moc"
