/***************************************************************************
 *   Copyright (C) 2014-2022 by Helge Kortendieck  alan@kasmithee.de       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/

#ifndef _PLAYLIST_H_
#define _PLAYLIST_H_

#include <QDialog>
#include <QListWidget>
#include <QListWidgetItem>
#include <QPoint>
#include <QString>
#include <QWidget>

#include "ui_playlist.h"

//#include "structs.h"


class PlayList : public QDialog
{
	Q_OBJECT

public:
	PlayList(QDialog* parent = 0);
		~PlayList();

private:
	int iD;
	int iD2;

	QString sCredits;

	QStringList slDSl;		// song list struct entity
//	SongList slDSl;			// song list struct entity

	Ui::Sl uisl;			// song list widget

	QDialog wSl;			// song list widget

	QPoint qPos;

private slots:
	void closeDlg();		// close dialog

	void showSl(const QStringList& slDSl);	// show about or help

	signals:
		void sigDelPlayList();
};

#endif
